local modName = g_currentModName
local modDir = g_currentModDirectory

local function load()
	local filename = modDir .. "modDesc.xml"

	local xmlFile = loadXMLFile("ModFile", filename)
	local i = 0

	while true do
		local key = string.format("modDesc.fillTypes.fillType(%d)", i)

		if not hasXMLProperty(xmlFile, key) then
			break
		end

		local name = getXMLString(xmlFile, key .. "#name")
		local title = getXMLString(xmlFile, key .. "#title")
		local showOnPriceTable = getXMLBool(xmlFile, key .. "#showOnPriceTable")
		local pricePerLiter = getXMLFloat(xmlFile, key .. "#pricePerLiter")
		local fillPlaneColorsString = getXMLString(xmlFile, key .. "#fillPlaneColors")
		local fillPlaneColors = {
			1,
			1,
			1
		}

		if fillPlaneColorsString ~= nil then
			fillPlaneColors = StringUtil.getVectorNFromString(fillPlaneColorsString, 3)
		end

		local massPerLiter = getXMLFloat(xmlFile, key .. ".physics#massPerLiter") / 1000
		local maxPhysicalSurfaceAngle = getXMLFloat(xmlFile, key .. ".physics#maxPhysicalSurfaceAngle")
		local hudFilename = getXMLString(xmlFile, key .. ".image#hud")
		local hudSmallFilename = getXMLString(xmlFile, key .. ".image#hudSmall")
		local palletFilename = getXMLString(xmlFile, key .. ".pallet#filename")

		g_fillTypeManager:addFillType(name, title, showOnPriceTable, pricePerLiter, massPerLiter, maxPhysicalSurfaceAngle, hudFilename, hudSmallFilename, modDir, modName, fillPlaneColors, palletFilename, false)

		i = i + 1
	end

	delete(xmlFile)
end

local function validateVehicleTypes()
	if g_modIsLoaded[modName] then
		load()
	end
end

VehicleTypeManager.validateVehicleTypes = Utils.prependedFunction(VehicleTypeManager.validateVehicleTypes, validateVehicleTypes)
