local modName = g_currentModName
local modDir = g_currentModDirectory

local function load()
	local filename = modDir .. "modDesc.xml"

	local xmlFile = loadXMLFile("ModFile", filename)
	local i = 0

	while true do
		local key = string.format("modDesc.placeableTypes.placeableType(%d)", i)

		if not hasXMLProperty(xmlFile, key) then
			break
		end

		local typeName = getXMLString(xmlFile, key .. "#name")

		if typeName == nil then
			break
		end

		local className = getXMLString(xmlFile, key .. "#className")
		local typeFilename = Utils.getFilename(getXMLString(xmlFile, key .. "#filename"), modDir)

		g_placeableTypeManager:addPlaceableType(typeName, modName .. "." .. className, typeFilename, modName)

		i = i + 1
	end

	delete(xmlFile)
end

local function validateVehicleTypes()
	if g_modIsLoaded[modName] then
		load()
	end
end

VehicleTypeManager.validateVehicleTypes = Utils.prependedFunction(VehicleTypeManager.validateVehicleTypes, validateVehicleTypes)
